/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hashovac;

import hashovac.MD55.*;
import hashovac.SHA11.*;
import hashovac.RC44.*;
import hashovac.Pearsonn.*;
import hashovac.MurmurHashh.*;
import hashovac.FNV.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

/**
 *
 * @author Lenka
 */
class Funkcie {

    private final static char[] hexArray = "0123456789abcdef".toCharArray();

    public static String bytesToHex(byte[] bytes) {
        char[] hexChars = new char[bytes.length * 2];
        for (int j = 0; j < bytes.length; j++) {
            int v = bytes[j] & 0xFF;
            hexChars[j * 2] = hexArray[v >>> 4];
            hexChars[j * 2 + 1] = hexArray[v & 0x0F];
        }
        return new String(hexChars);
    }

    public static String toHexString(String input) {
        return String.format("%x", new BigInteger(1, input.getBytes()));
    }
//
//    public static String fromHexString(String hex) {
//        StringBuilder str = new StringBuilder();
//        for (int i = 0; i < hex.length(); i+=2) {
//            str.append((char) Integer.parseInt(hex.substring(i, i + 2), 16));
//        }
//        return str.toString();
//    }

    public static String HexStringToByteArray(String hex) {
        StringBuilder str = new StringBuilder();
        for (int i = 0; i < hex.length(); i += 2) {
            str.append((char) Integer.parseInt(hex.substring(i, i + 2), 16));
        }
        return str.toString();
    }

    public static byte[] hexStringToByteArray(String s) {
        int len = s.length();
        byte[] data = new byte[len / 2];
        for (int i = 0; i < len; i += 2) {
            data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
                    + Character.digit(s.charAt(i + 1), 16));
        }
        return data;
    }

    static void OrigMD5() throws FileNotFoundException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));

        pw.println("MD5 Originál");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }

    static void MD51mod1() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 chyba v shifte, zabudnutie na premennú pri ENCODE");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5mod1.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    static void MD52mod2() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 chyba v shifte, zabudnutie na premennú pri DECODE");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5mod2.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void MD53Padd() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 iný padding");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5Padding.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void MD54ik() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 iné konštanty");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5ik.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void MD55NK() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 neinicializované konštanty");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5NI.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    
    /*
    ** ina implementacia, pokazeny for cyklus
    */
    static void MD5iiFor() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 iná implementácia, pokazený for cyklus");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5inaImpl_pokFor.toHexString(MD5inaImpl_pokFor.computeMD5inaImpl_pokFor(b))).toLowerCase();
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
     
    }
    
    static void MD5iiShift() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 iná implementácia, neinic. shift tabuľka");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5iiShift.toHexString(MD5iiShift.computeMD5iiShift(b))).toLowerCase();
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
     
    }
    
    static void MD5zabudMV() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 nepripočítavanie medzivýsledkov");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5ZabPripMV.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void MD5nepochopPK() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 zlá interpretácia pesudokódu");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5ZlePochop.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void MD5len1kolo() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("MD5 len jedno kolo - F");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = new String(MD5lenJednoKolo.getHashString(b));
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void OrigSHA1() throws FileNotFoundException, IOException {
        SHA1 sh = new SHA1();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 Originál");

        String s = br.readLine();
        while (s != null) {
            // s = fromHexString(s);
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void SHA1_1NIn() throws FileNotFoundException, IOException {
        SHA1NI sh = new SHA1NI();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 neinicializované konštanty");

        String s = br.readLine();
        while (s != null) {
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void SHA1_2IneKonstanty() throws FileNotFoundException, IOException {
        SHA1ik sh = new SHA1ik();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 iné konštanty");

        String s = br.readLine();
        while (s != null) {
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
//    static void SHA1_3lomenaMiestoZvislej() throws FileNotFoundException, IOException {
//        SHA1lomena sh = new SHA1lomena();
//        
//        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
//        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
//        pw.println("SHA1 lomená čiara miesto zvislej");
//        
//        String s = br.readLine();
//        while (s != null) {
//            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
//            pw.println("" + hash + "");
//            s = br.readLine();
//        }
//        br.close();
//        pw.close();
//    }

    static void SHA1_4andOr() throws FileNotFoundException, IOException {
        SHA1AndOr sh = new SHA1AndOr();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 and namiesto or");

        String s = br.readLine();
        while (s != null) {
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void SHA1_5orAnd() throws FileNotFoundException, IOException {
        SHA1OrAnd sh = new SHA1OrAnd();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 or namiesto and");

        String s = br.readLine();
        while (s != null) {
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void SHA1_6pokFor() throws FileNotFoundException, IOException {
        SHA1pokFor sh = new SHA1pokFor();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 pokazený for cyklus");

        String s = br.readLine();
        while (s != null) {
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void SHA1_7shift2x3x() throws FileNotFoundException, IOException {
        SHA1shift2x3x sh = new SHA1shift2x3x();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 shift << namiesto <<< a naopak");

        String s = br.readLine();
        while (s != null) {
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void SHA1_8nepochop() throws FileNotFoundException, IOException {
        SHA1nepochopXorPlus sh = new SHA1nepochopXorPlus();

        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("SHA1 plus namisto xoru a - namiesto ~");

        String s = br.readLine();
        while (s != null) {
            String hash = bytesToHex(sh.digest(hexStringToByteArray(s)));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    

    static void OrigRC4() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 Originál");

        String testiiik = "0000000000000000000000000000000000000000000000000000000000000000";
        byte[] text = hexStringToByteArray(testiiik);

        String s = br.readLine();

        while (s != null) {
            byte[] kluc = hexStringToByteArray(s);
            RC4 rc4 = new RC4(kluc);
            String hash = bytesToHex(rc4.encrypt(text));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void RC4_1NISB() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 Sbox_lenght inic o polovicu menej");

        String testiiik = "0000000000000000000000000000000000000000000000000000000000000000";
        byte[] text = hexStringToByteArray(testiiik);

        String s = br.readLine();

        while (s != null) {
            byte[] kluc = hexStringToByteArray(s);
            RC4NSbox rc4 = new RC4NSbox(kluc);
            String hash = bytesToHex(rc4.encrypt(text));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void RC4_2swap() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 chyba v swape");

        String testiiik = "0000000000000000000000000000000000000000000000000000000000000000";
        byte[] text = hexStringToByteArray(testiiik);

        String s = br.readLine();

        while (s != null) {
            byte[] kluc = hexStringToByteArray(s);
            RC4ZSwap rc4 = new RC4ZSwap(kluc);
            String hash = bytesToHex(rc4.encrypt(text));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void RC4_3forVInitb() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 pokazený for v initBox");

        String testiiik = "0000000000000000000000000000000000000000000000000000000000000000";
        byte[] text = hexStringToByteArray(testiiik);

        String s = br.readLine();

        while (s != null) {
            byte[] kluc = hexStringToByteArray(s);
            RC4forInit rc4 = new RC4forInit(kluc);
            String hash = bytesToHex(rc4.encrypt(text));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void RC4_4forVEncrypt() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 Pokazený for pri encrypt");

        String testiiik = "0000000000000000000000000000000000000000000000000000000000000000";
        byte[] text = hexStringToByteArray(testiiik);

        String s = br.readLine();

        while (s != null) {
            byte[] kluc = hexStringToByteArray(s);
            RC4forEnc rc4 = new RC4forEnc(kluc);
            String hash = bytesToHex(rc4.encrypt(text));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void RC4_5swapXor() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 chyba v swape (pomocou XOR)");

        String testiiik = "0000000000000000000000000000000000000000000000000000000000000000";
        byte[] text = hexStringToByteArray(testiiik);

        String s = br.readLine();

        while (s != null) {
            byte[] kluc = hexStringToByteArray(s);
            RC4ZSwapXor rc4 = new RC4ZSwapXor(kluc);
            String hash = bytesToHex(rc4.encrypt(text));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void RC4_6neinicPole() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 neinicializovaná tabuľka");

        String testiiik = "0000000000000000000000000000000000000000000000000000000000000000";
        byte[] text = hexStringToByteArray(testiiik);

        String s = br.readLine();

        while (s != null) {
            byte[] kluc = hexStringToByteArray(s);
            RC4neinicPole rc4 = new RC4neinicPole(kluc);
            String hash = bytesToHex(rc4.encrypt(text));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    ////TATO RC4 BERIE VSTUP AKO STRINGY NA HASHOVANIE A NIE AKO KLUCE
    static void RC4_konstKluc() throws IOException, IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("RC4 Originál, ale konštantný kľúč, stringy ako vstupy");
        
        //////////////////////////////KEY KEY
        String key = "key";
        RC4 rc4 = new RC4(key.getBytes());
        //////////////////////////////KEY KEY
        
        String s = br.readLine();
        
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            rc4 = new RC4(key.getBytes());
            String hash = bytesToHex(rc4.encrypt(b));
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    
    static void OrigMurmur() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur hash Originál");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHash.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }

    static void Murmur1NM() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur neinicializované m");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashNM.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }

    static void Murmur2Nr() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur neinicializované r");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashNr.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }

    static void Murmur3Nh() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur neinicializované h");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashNH.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }

    static void Murmur4PosunutaLen() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur zle posunuta dĺžka");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashZPL.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }

//    static void Murmur5Deleno() throws IOException {
//        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
//        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
//        pw.println("Murmur / miesto |");
//        String s = br.readLine();
//        while (s != null) {
//            byte[] b = hexStringToByteArray(s);
//            String hash = Integer.toHexString(MurmurHashLomenaCiara.hash(b, 0));
//            while (hash.length() != 8) {
//                StringBuilder sb = new StringBuilder();
//                sb.append("0");
//                sb.append(hash);
//                hash = sb.toString();
//            }
//            pw.println("" + hash + "");
//
//            s = br.readLine();
//        }
//        br.close();
//        pw.close();
//
//    }

    static void Murmur6AndOr() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur namiesto And Or");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashAndOr.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }

    static void Murmur7ForBezZat() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur for cyklus bez zatvoriek");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashForBez.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }
    
    
    static void Murmur8neinicrh() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur Neinicializované r ani h");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashNeinrh.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }
    
    
    static void Murmur9NepochopPlusXor() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur namiesto xoru plus");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashNepochop.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }
    
    
    static void Murmur10Shift2x3x() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Murmur naopak dané oparácie >> a >>>");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Integer.toHexString(MurmurHashShift2x3x.hash(b, 0));
            while (hash.length() != 8) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");

            s = br.readLine();
        }
        br.close();
        pw.close();

    }
//
//    static void Murmur8ForKoniec() throws IOException {
//        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
//        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
//        pw.println("Murmur bodkočiarka za for");
//        String s = br.readLine();
//        while (s != null) {
//            byte[] b = hexStringToByteArray(s);
//            String hash = Integer.toHexString(MurmurHashForKoniec.hash(b, 0));
//            while (hash.length() != 8) {
//                StringBuilder sb = new StringBuilder();
//                sb.append("0");
//                sb.append(hash);
//                hash = sb.toString();
//            }
//            pw.println("" + hash + "");
//
//            s = br.readLine();
//        }
//        br.close();
//        pw.close();
//    }

    static void OrigFNV() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a Originál");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHash.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void FNVnoI() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a nenainicializovane");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHashNI.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void FNVnoPE() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a nepárne neprvočíslo");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHashNPE.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void FNVnoPO() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a párne neprvočíslo");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHashNPO.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void FNVfk() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a zlý for cyklus zabudnuté zátvorky (len 1.príkaz)");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHashfk.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void FNVfkoniec() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a za for cyklom koniec hneď");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHashfkoniec.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void FNVnoIPrime() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a neinicializované prvočíslo");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHashNoIPrime.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void FNVNepochop() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("FNV1a Nepochopený pseudokód - miseto XOR Plus");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            String hash = Long.toHexString(FNVHashNepoch.hash64(b));
            while (hash.length() != 16) {
                StringBuilder sb = new StringBuilder();
                sb.append("0");
                sb.append(hash);
                hash = sb.toString();
            }
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void OrigPearson() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Pearson hashing Originál");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            byte[] a = Pearson.Pearson16(b);
            String hash = bytesToHex(a);
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void Pearson1NP() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Pearson neinicializované pole");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            byte[] a = PearsonNP.Pearson16(b);
            String hash = bytesToHex(a);
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void Pearson2ZleInPole() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Pearson zle rozhádzané pole");
        PearsonZlePole.inicializujPole();
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            byte[] a = PearsonZlePole.Pearson16(b);
            String hash = bytesToHex(a);
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void Pearson3PoradiePole() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Pearson pole 0,1,..255 lineárne");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            byte[] a = PearsonLinP.Pearson16(b);
            String hash = bytesToHex(a);
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

    static void Pearson4KopciaciPreklep() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Pearson preklep v cykle x[0]");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            byte[] a = PearsonPreklepVCykle.Pearson16(b);
            String hash = bytesToHex(a);
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void Pearson5PokFor() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Pearson Pokazený For cyklus");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            byte[] a = PearsonPokFor.Pearson16(b);
            String hash = bytesToHex(a);
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }
    
    static void Pearson6Nepoch() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vystup.txt")));
        BufferedReader br = new BufferedReader(new FileReader(new File("vstup.txt")));
        pw.println("Pearson Nepochopený pseudokód - Plus miesto Xor");
        String s = br.readLine();
        while (s != null) {
            byte[] b = hexStringToByteArray(s);
            byte[] a = PearsonNepochop.Pearson16(b);
            String hash = bytesToHex(a);
            pw.println("" + hash + "");
            s = br.readLine();
        }
        br.close();
        pw.close();
    }

}
