package hashovac.Pearsonn;

/**
 *
 * @author Lenka
 */
public class PearsonPokFor {

    public static byte[] Pearson16(byte[] x) {
        int i,j =0;
        byte[] hh = new byte[8];
        byte[] T = {
            (byte) 98, (byte) 6, (byte) 85, (byte) 150, (byte) 36, (byte) 23, (byte) 112, (byte) 164, (byte) 135, (byte) 207, (byte) 169, (byte) 5, (byte) 26, (byte) 64, (byte) 165, (byte) 219, (byte)
            61, (byte) 20, (byte) 68, (byte) 89, (byte) 130, (byte) 63, (byte) 52, (byte) 102, (byte) 24, (byte) 229, (byte) 132, (byte) 245, (byte) 80, (byte) 216, (byte) 195, (byte) 115, (byte)
            90, (byte) 168, (byte) 156, (byte) 203, (byte) 177, (byte) 120, (byte) 2, (byte) 190, (byte) 188, (byte) 7, (byte) 100, (byte) 185, (byte) 174, (byte) 243, (byte) 162, (byte) 10, (byte)
            237, (byte) 18, (byte) 253, (byte) 225, (byte) 8, (byte) 208, (byte) 172, (byte) 244, (byte) 255, (byte) 126, (byte) 101, (byte) 79, (byte) 145, (byte) 235, (byte) 228, (byte) 121, (byte)
            123, (byte) 251, (byte) 67, (byte) 250, (byte) 161, (byte) 0, (byte) 107, (byte) 97, (byte) 241, (byte) 111, (byte) 181, (byte) 82, (byte) 249, (byte) 33, (byte) 69, (byte) 55, (byte)
            59, (byte) 153, (byte) 29, (byte) 9, (byte) 213, (byte) 167, (byte) 84, (byte) 93, (byte) 30, (byte) 46, (byte) 94, (byte) 75, (byte) 151, (byte) 114, (byte) 73, (byte) 222, (byte)
            197, (byte) 96, (byte) 210, (byte) 45, (byte) 16, (byte) 227, (byte) 248, (byte) 202, (byte) 51, (byte) 152, (byte) 252, (byte) 125, (byte) 81, (byte) 206, (byte) 215, (byte) 186, (byte)
            39, (byte) 158, (byte) 178, (byte) 187, (byte) 131, (byte) 136, (byte) 1, (byte) 49, (byte) 50, (byte) 17, (byte) 141, (byte) 91, (byte) 47, (byte) 129, (byte) 60, (byte) 99, (byte)
            154, (byte) 35, (byte) 86, (byte) 171, (byte) 105, (byte) 34, (byte) 38, (byte) 200, (byte) 147, (byte) 58, (byte) 77, (byte) 118, (byte) 173, (byte) 246, (byte) 76, (byte) 254, (byte)
            133, (byte) 232, (byte) 196, (byte) 144, (byte) 198, (byte) 124, (byte) 53, (byte) 4, (byte) 108, (byte) 74, (byte) 223, (byte) 234, (byte) 134, (byte) 230, (byte) 157, (byte) 139, (byte)
            189, (byte) 205, (byte) 199, (byte) 128, (byte) 176, (byte) 19, (byte) 211, (byte) 236, (byte) 127, (byte) 192, (byte) 231, (byte) 70, (byte) 233, (byte) 88, (byte) 146, (byte) 44, (byte)
            183, (byte) 201, (byte) 22, (byte) 83, (byte) 13, (byte) 214, (byte) 116, (byte) 109, (byte) 159, (byte) 32, (byte) 95, (byte) 226, (byte) 140, (byte) 220, (byte) 57, (byte) 12, (byte)
            221, (byte) 31, (byte) 209, (byte) 182, (byte) 143, (byte) 92, (byte) 149, (byte) 184, (byte) 148, (byte) 62, (byte) 113, (byte) 65, (byte) 37, (byte) 27, (byte) 106, (byte) 166, (byte)
            3, (byte) 14, (byte) 204, (byte) 72, (byte) 21, (byte) 41, (byte) 56, (byte) 66, (byte) 28, (byte) 193, (byte) 40, (byte) 217, (byte) 25, (byte) 54, (byte) 179, (byte) 117, (byte)
            238, (byte) 87, (byte) 240, (byte) 155, (byte) 180, (byte) 170, (byte) 242, (byte) 212, (byte) 191, (byte) 163, (byte) 78, (byte) 218, (byte) 137, (byte) 194, (byte) 175, (byte) 110, (byte)
            43, (byte) 119, (byte) 224, (byte) 71, (byte) 122, (byte) 142, (byte) 42, (byte) 160, (byte) 104, (byte) 48, (byte) 247, (byte) 103, (byte) 15, (byte) 11, (byte) 138, (byte) 239
        };

        byte h = 0;
        int k = 0;
        for (k = 0; k < 8; ++k) 
            j = k;
            h = T[Math.floorMod((x[0] + j), 256)];
            //h = T[(h + x[0] + j) % 256]; // johnfound's "improved" version //h = T[Math.floorMod((h + x[0] + j), 256)];
            for (i = 1; i < x.length; ++i)
                h = T[Math.floorMod((h ^ x[i]), 256) ];
            hh[j] = h;
        
        return hh;
    }
}
