/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package prng;

import prng.MT.*;
import prng.LCG.*;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Random;
import java.util.function.IntConsumer;
import java.util.stream.IntStream;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 *
 * @author Lenka
 */
class Funkcie {

    public static int pocetGenerovani = 1000;
    public final static int cisloMax = Integer.MAX_VALUE; //Integer.MAX_VALUE;

    static void OrigLCG() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG originál");

        Stage st = opytajSaNaPocet();
        st.showAndWait();

//        LinearCongruentialGenerator lcg = new LinearCongruentialGenerator();
//        int seed =1234555;
//        
//        
//        IntConsumer action = new IntConsumer() {
//            @Override
//            public void accept(int value) {
//                pw.println("" + Integer.toHexString(value) + "");
//                System.out.println("" + value);
//            }
//        };
//        
//        lcg.randBSD(seed).limit(pocetGenerovani).forEach(action);
        LCGRandom lcg = new LCGRandom(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            //long a = lcg.igen();
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }

        pw.close();

    }

    static void LCG1seed0() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG seed 0");

        Stage st = opytajSaNaPocet();
        st.showAndWait();
        LCGRandomS0 lcg = new LCGRandomS0(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }
        pw.close();
    }

    static void LCG2seed1() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG seed 1");

        Stage st = opytajSaNaPocet();
        st.showAndWait();
        LCGRandomSeed1 lcg = new LCGRandomSeed1(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }
        pw.close();
    }

    static void LCG3parneMax() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG maximum je párne");

        Stage st = opytajSaNaPocet();
        st.showAndWait();
        LCGRandomMaxParne lcg = new LCGRandomMaxParne(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }
        pw.close();
    }

    static void LCG4MaxNepAleZlozene() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG maximum je zložené ale nepárne");

        Stage st = opytajSaNaPocet();
        st.showAndWait();
        LCGRandomMaxNepZloz lcg = new LCGRandomMaxNepZloz(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }
        pw.close();
    }

    static void LCG5mensieA() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG násobič je menší aj seed je menší");

        Stage st = opytajSaNaPocet();
        st.showAndWait();
        LCGRandomMensieA lcg = new LCGRandomMensieA(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }
        pw.close();
    }
    static void LCG6neiA() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG neinicializované a");

        Stage st = opytajSaNaPocet();
        st.showAndWait();
        LCGRandomNeiA lcg = new LCGRandomNeiA(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }
        pw.close();
    }
    static void LCG7VsetkyKonstantyZmenene() throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("LCG všetky konštanty trochu upravené");

        Stage st = opytajSaNaPocet();
        st.showAndWait();
        LCGRandomVKZ lcg = new LCGRandomVKZ(0);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = (int) (lcg.gen() * cisloMax);
            pw.println("" + a + "");
        }
        pw.close();
    }

    static void OrigMT() throws IOException {                                       /////////////// 20 000 000 dalo do 10 sekund
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("Mersene Twist originál");

        Stage st = opytajSaNaPocet();
        st.showAndWait();

        MersenneTwisterFast mt = new MersenneTwisterFast();
        mt.setSeed(1);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = mt.nextInt(cisloMax);
            pw.println("" + a + "");
        }

        pw.close();

    }
    static void MT1IK() throws IOException {                                       /////////////// 20 000 000 dalo do 10 sekund
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("Mersene Twist Iné konštanty");

        Stage st = opytajSaNaPocet();
        st.showAndWait();

        MersenneTwisterFastIK mt = new MersenneTwisterFastIK();
        mt.setSeed(1);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = mt.nextInt(cisloMax);
            pw.println("" + a + "");
        }

        pw.close();

    }
    static void MT2NeiK() throws IOException {                                       /////////////// 20 000 000 dalo do 10 sekund
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("Mersene Twist neinicial. konštanty aj tá zo seedu");

        Stage st = opytajSaNaPocet();
        st.showAndWait();

        MersenneTwisterFastNeIK mt = new MersenneTwisterFastNeIK();
        mt.setSeed(1);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = mt.nextInt(cisloMax);
            pw.println("" + a + "");
        }

        pw.close();

    }
    static void MT3Nieco() throws IOException {                                       /////////////// 20 000 000 dalo do 10 sekund
        PrintWriter pw = new PrintWriter(new FileWriter(new File("prng.txt")));
        pw.println("Mersene Twist zo seedu konštanta");

        Stage st = opytajSaNaPocet();
        st.showAndWait();

        MersenneTwisterFastNieco mt = new MersenneTwisterFastNieco();
        mt.setSeed(1);
        for (int i = 0; i < pocetGenerovani; i++) {
            int a = mt.nextInt(cisloMax);
            pw.println("" + a + "");
        }

        pw.close();

    }

    private static Stage opytajSaNaPocet() {
        Stage primaryStage = new Stage();

        Label nLabel = new Label("Počet generovaní: (kladný integer)");
        TextField pViet = new TextField();

        Button ok = new Button("Ok");

        ok.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                try {

                    String text = pViet.getText();
                    try {
                        int test = Integer.parseInt(text);
                    } catch (Exception e) {
                        System.err.println("ERR:Zle cislo 1..");
                        Alert alert = new Alert(Alert.AlertType.ERROR);
                        alert.setContentText("Zlé 1.číslo, zadávajte prosím len KLADNÉ čísla v rozsahu INTEGER");
                        alert.showAndWait();
                    }
                    final int pocet = Integer.parseInt(text);
                    if (pocet < 0 || pocet > Integer.MAX_VALUE) {
                        Alert alert = new Alert(Alert.AlertType.ERROR);
                        alert.setContentText("Zlé čísla, zadávajte prosím len KLADNÉ čísla v rozsahu INTEGER");
                        alert.showAndWait();
                        throw new IllegalArgumentException("Nesedi logika.. Zamyslite sa nad svojimi cislami!");
                    }
                    pocetGenerovani = pocet;
//                    System.out.println("Menim pocet generovanie ");
//                    System.out.println("mam pocet gen " + pocetGenerovani);
                    primaryStage.close();
                } catch (Exception e) {
                    System.err.println("ERR:Nieco sa pokazilo, skuste este raz a zadajte vhodne cisla - INTEGER \n " + e.getMessage());
                }

            }
        });

        VBox root = new VBox();

        root.getChildren().addAll(nLabel, pViet, ok);

        Scene scene = new Scene(root, 300, 250);
        scene.getStylesheets().add("Styles.css");

        primaryStage.setTitle("Generátor");
        primaryStage.setMinHeight(100);
        primaryStage.setMinWidth(600);
        primaryStage.setScene(scene);
        return primaryStage;
    }

}
