package prng.LCG;

import static java.lang.System.*;

public class LCGRandomSeed1
{
    public  static final int    MAX_STREAMS = 10;
    private static final long   a        = 16807;       // 7^5  NP
    private static final long   m        = 2147483647;  // 2^31 - 1  Prime
    private static final double one_by_m = 1.0 / m;

    private static final long   SEED [] = { 1,
                                           1954324947,   // only for 16807
                                           1145661099,
                                           1835732737,
                                            794161987,
                                           1329531353,
                                            200496737,
                                            633816299,
                                           1410143363,
                                           1282538739 };

    private int  stream;

    private long  x;

    private  final Double []  params = new Double [1];

    public LCGRandomSeed1 (int stream)
    {
        this.stream  = stream;
        x = SEED [stream];
        params [0] = new Double (stream);

    }

    public void incrStream () 
    {
        stream++;
        params [0] = new Double (stream);

    }

    public Double [] getParameters ()
    {
        return  params;
    }

    public double gen ()
    {
        x = (a * x) % m;    // 64-bit integer arithmetic
        return ((double) x) * one_by_m;
    } 

    public long igen ()
    {
        x = (a * x) % m;    // 64-bit integer arithmetic

        return x;

    } // igen
}
