/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package prng_vlastnosti;

import java.util.Vector;
import javafx.scene.Scene;
import javafx.scene.chart.BarChart;
import javafx.scene.chart.CategoryAxis;
import javafx.scene.chart.NumberAxis;
import javafx.scene.chart.ScatterChart;
import javafx.scene.chart.XYChart;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 *
 * @author Lenka
 */
class vlastnost {
    
    static void modulo(int modulo, Vector<Integer> vstup) {
           //
        int[] hodnoty = new int[modulo];
        for (int i = 0; i < modulo; i++) {
            hodnoty[i] = 0;
        }
        
        for (int i = 0; i < vstup.size(); i++) {
            int z = (vstup.get(i)) % (modulo);
            hodnoty[z]++;
        }

        Stage primaryStage = new Stage();

        primaryStage.setTitle(PRNG_vlastnosti.nazov);
        
        CategoryAxis xAxis = new CategoryAxis();
        xAxis.setLabel("Modulá (pre počet vstupov " + vstup.size()  +")");

        NumberAxis yAxis = new NumberAxis();
        yAxis.setLabel("Počet (priemer " + (vstup.size()/modulo) + ")");

        BarChart barChart = new BarChart(xAxis, yAxis);

        XYChart.Series dataSeries1 = new XYChart.Series();
        dataSeries1.setName(PRNG_vlastnosti.nazov + " modulo " + modulo);
        for (int i = 0; i < modulo; i++) {
            dataSeries1.getData().add(new XYChart.Data(Integer.toString(i), hodnoty[i]));
        }

        barChart.getData().add(dataSeries1);

        VBox vbox = new VBox(barChart);

        Scene scene = new Scene(vbox, 400, 200);

        primaryStage.setScene(scene);
        primaryStage.setHeight(300);
        primaryStage.setWidth(1200);

        primaryStage.show();

    }
    
//    
//    static void linear(Vector<Integer> vstup) {
//        Stage stage = new Stage();
//        stage.setTitle("Zobrazenie v čase");
//        final NumberAxis xAxis = new NumberAxis(-1, vstup.size(), 1);
//        final NumberAxis yAxis = new NumberAxis(-1000, Integer.MAX_VALUE, (Integer.MAX_VALUE/100));        
//        final ScatterChart<Number,Number> sc = new
//            ScatterChart<Number,Number>(xAxis,yAxis);
//        xAxis.setLabel("Vstup v poradí");                
//        yAxis.setLabel("Vstup hodnota");
//        sc.setTitle("" + PRNG_vlastnosti.nazov + " v čase..");
//       
//        XYChart.Series series1 = new XYChart.Series();
//        //series1.setName("Equities");
//        series1.setName(null);
//        for (int i =0;i<vstup.size();i++){
//            series1.getData().add(new XYChart.Data(i, vstup.get(i)));    
//        }
//        
//        sc.getData().addAll(series1);
//        Scene scene  = new Scene(sc, 800, 600);
//        stage.setScene(scene);
//        stage.show();
//        
//    }
    
    static void linear(Vector<Integer> vstup) {
        int max = 0;
        int min = Integer.MAX_VALUE;
        Stage stage = new Stage();
        stage.setTitle("Zobrazenie v čase");
        final NumberAxis xAxis = new NumberAxis(-1, vstup.size(), 1);
        final NumberAxis yAxis = new NumberAxis(-1000, Integer.MAX_VALUE, (Integer.MAX_VALUE/100));        
        final ScatterChart<Number,Number> sc = new
            ScatterChart<Number,Number>(xAxis,yAxis);
        xAxis.setLabel("Vstup v poradí");                
        yAxis.setLabel("Vstup hodnota");
        sc.setTitle("" + PRNG_vlastnosti.nazov + " v čase..");
       
        XYChart.Series series1 = new XYChart.Series();
        //series1.setName("Equities");
        series1.setName(null);
        for (int i =0;i<vstup.size();i++){
            if (vstup.get(i)>max) max = vstup.get(i);
            if (vstup.get(i)<min) min = vstup.get(i);
            series1.getData().add(new XYChart.Data(i, vstup.get(i)));    
        }
        yAxis.setUpperBound(max);
        yAxis.setLowerBound(min);
        sc.getData().addAll(series1);
        Scene scene  = new Scene(sc, 800, 600);
        stage.setScene(scene);
        stage.show();
        
    }
    
}
